package com.sun.xml.internal.ws.api.model.wsdl;

import com.sun.xml.internal.ws.wsdl.parser.RuntimeWSDLParser;
import com.sun.xml.internal.ws.api.policy.PolicyResolver;
import com.sun.xml.internal.ws.api.policy.PolicyResolverFactory;
import org.xml.sax.SAXException;
import javax.xml.stream.XMLStreamException;
import java.io.IOException;
import com.sun.xml.internal.ws.api.server.Container;
import com.sun.xml.internal.ws.api.wsdl.parser.WSDLParserExtension;
import com.sun.xml.internal.ws.api.wsdl.parser.XMLEntityResolver;
import com.sun.xml.internal.ws.policy.PolicyMap;
import java.util.Map;
import com.sun.istack.internal.NotNull;
import javax.xml.namespace.QName;

public interface WSDLModel extends WSDLExtensible
{
    public abstract WSDLPortType getPortType(@NotNull QName p0);
    
    public abstract WSDLBoundPortType getBinding(@NotNull QName p0);
    
    public abstract WSDLBoundPortType getBinding(@NotNull QName p0, @NotNull QName p1);
    
    public abstract WSDLService getService(@NotNull QName p0);
    
    @NotNull
    public abstract Map<QName, ? extends WSDLPortType> getPortTypes();
    
    @NotNull
    public abstract Map<QName, ? extends WSDLBoundPortType> getBindings();
    
    @NotNull
    public abstract Map<QName, ? extends WSDLService> getServices();
    
    public abstract QName getFirstServiceName();
    
    public abstract WSDLMessage getMessage(QName p0);
    
    @NotNull
    public abstract Map<QName, ? extends WSDLMessage> getMessages();
    
    @Deprecated
    public abstract PolicyMap getPolicyMap();
    
    public static class WSDLParser
    {
        @NotNull
        public static WSDLModel parse(XMLEntityResolver.Parser wsdlEntityParser, XMLEntityResolver resolver, boolean isClientSide, WSDLParserExtension... extensions) throws IOException, XMLStreamException, SAXException {
            return parse(wsdlEntityParser, resolver, isClientSide, Container.NONE, extensions);
        }
        
        @NotNull
        public static WSDLModel parse(XMLEntityResolver.Parser wsdlEntityParser, XMLEntityResolver resolver, boolean isClientSide, @NotNull Container container, WSDLParserExtension... extensions) throws IOException, XMLStreamException, SAXException {
            return parse(wsdlEntityParser, resolver, isClientSide, container, PolicyResolverFactory.create(), extensions);
        }
        
        @NotNull
        public static WSDLModel parse(XMLEntityResolver.Parser wsdlEntityParser, XMLEntityResolver resolver, boolean isClientSide, @NotNull Container container, PolicyResolver policyResolver, WSDLParserExtension... extensions) throws IOException, XMLStreamException, SAXException {
            return RuntimeWSDLParser.parse(wsdlEntityParser, resolver, isClientSide, container, policyResolver, extensions);
        }
    }
}
